## deepin-movie-reborn 5.10.15

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

set(CMAKE_AUTOMOC ON)
set(CMD_NAME deepin-movie)

set(PROJECT_INCLUDE ${PROJECT_SOURCE_DIR}/src/widgets
    ${PROJECT_SOURCE_DIR}/src/common
    ${PROJECT_SOURCE_DIR}/src/libdmr
    ${PROJECT_SOURCE_DIR}/src/dlna)

add_definitions(-D_MOVIE_USE_)

include_directories(${CMAKE_INCLUDE_CURRENT_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

find_package(Qt5Widgets)
find_package(Qt5DBus)
find_package(Qt5X11Extras)
find_package(Qt5LinguistTools)
find_package(Qt5Network)
find_package(Qt5Concurrent)
find_package(Qt5Sql)
find_package(Qt5Svg)
find_package(Qt5Multimedia)
find_package(Qt5MultimediaWidgets)
find_package(Qt5Xml)

pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkwidget)
pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkcore)
pkg_check_modules(Xcb REQUIRED IMPORTED_TARGET xcb xcb-shape)
pkg_check_modules(DBusextended REQUIRED IMPORTED_TARGET dbusextended-qt5)
pkg_check_modules(Gst REQUIRED IMPORTED_TARGET gobject-2.0)
# IMPORTED_TARGET failed to work for some of libs under flatpak env
pkg_check_modules(Other REQUIRED  gsettings-qt)

qt5_add_resources(RCS ../assets/resources.qrc)
qt5_add_resources(RCS ../assets/icons/theme-icons.qrc)
if (${Dtk_VERSION} LESS 2.0.6.1)
    qt5_add_resources(RCS ../assets/theme.qrc)
endif()


file(GLOB_RECURSE SRCS LIST_DIRECTORIES false common/*.cpp widgets/*.cpp libdmr/*.cpp vendor/*.cpp dlna/*.cpp dlna/*.c)
list(APPEND SRCS main.cpp)

# mpv backend
file(GLOB_RECURSE MPV_SRCS LIST_DIRECTORIES false backends/mpv/*.cpp)
file(GLOB_RECURSE MEDIAPLAYER_SRCS LIST_DIRECTORIES false backends/mediaplayer/*.cpp)
list(APPEND SRCS ${MPV_SRCS} ${MEDIAPLAYER_SRCS})
list(APPEND PROJECT_INCLUDE ${PROJECT_SOURCE_DIR}/src/backends/mpv)
list(APPEND PROJECT_INCLUDE ${PROJECT_SOURCE_DIR}/src/backends/mediaplayer)
list(APPEND PROJECT_INCLUDE /usr/include/glib-2.0 /usr/include/gstreamer-1.0)
#~

set (DTK_SETTINGS_TOOLS_EXECUTABLE ${DTKCORE_TOOL_DIR}/dtk-settings)
if (EXISTS ${DTK_SETTINGS_TOOLS_EXECUTABLE})
add_custom_target(json_i18n ALL
        ${DTKCORE_TOOL_DIR}/dtk-settings resources/data/settings.json -o common/settings_translation.cpp
    COMMAND sed -i "s,#include .*,#include <DSettings>," common/settings_translation.cpp
    VERBATIM
    SOURCES resources/data/settings.json
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/src/)

endif ()
## translations
file(GLOB TS LIST_DIRECTORIES false ../translations/${CMD_NAME}*.ts)

set_source_files_properties(${TS}
    PROPERTIES OUTPUT_LOCATION ${PROJECT_SOURCE_DIR}/translations)

if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    qt5_create_translation(QM ${SRCS} ${TS})
endif ()
# ~

add_executable(${CMD_NAME} ${SRCS} ${RCS} ${QM})

target_include_directories(${CMD_NAME} PUBLIC ${PROJECT_INCLUDE})

set(TARGET_LIBS X11 Xtst PkgConfig::Xcb Qt5::Widgets Qt5::X11Extras Qt5::Network Qt5::DBus Qt5::Sql Qt5::Svg Qt5::Multimedia
    Qt5::MultimediaWidgets PkgConfig::Dtk PkgConfig::MPRIS PkgConfig::DBusextended PkgConfig::Gst GL va va-x11
    Qt5::Concurrent Qt5::Xml)

target_link_libraries(${CMD_NAME} ${TARGET_LIBS} ${Other_LIBRARIES})


install(TARGETS ${CMD_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
install(DIRECTORY ${PROJECT_SOURCE_DIR}/translations
    DESTINATION ${CMAKE_INSTALL_DATADIR}/${CMD_NAME}
    FILES_MATCHING PATTERN "*.qm")
install(FILES ${PROJECT_SOURCE_DIR}/deepin-movie.desktop
    DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
install(FILES ${CMAKE_SOURCE_DIR}/src/libdmr/com.deepin.deepin-movie.gschema.xml
    DESTINATION ${CMAKE_INSTALL_DATADIR}/glib-2.0/schemas)
install(FILES ${PROJECT_SOURCE_DIR}/assets/resources/icons/logo-big.svg
    DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps
    RENAME deepin-movie.svg)
install(DIRECTORY ${CMAKE_SOURCE_DIR}/assets/deepin-movie DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-manual/manual-assets/application/)

# 加速编译优化参数
if (CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")
    SET(CMAKE_CXX_FLAGS "$ENV{CXXFLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi -Wl,--as-needed -fPIE -z noexecstack")
    SET(CMAKE_C_FLAGS "$ENV{CFLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi -z noexecstack")
    SET(CMAKE_EXE_LINKER_FLAGS "-pie")
else()
    SET(CMAKE_CXX_FLAGS "$ENV{CXXFLAGS} -fstack-protector-strong -Wformat -Werror=format-security -Wdate-time -D_FORTIFY_SOURCE=2 -std=c++14 -O3 -DNDEBUG -fPIC -Wl,--as-needed -fPIE")
    SET(CMAKE_C_FLAGS "$ENV{CFLAGS} -fstack-protector-strong -Wformat -Werror=format-security -Wdate-time -D_FORTIFY_SOURCE=2 -std=c++14 -O3 -DNDEBUG -fPIC")
    SET(CMAKE_EXE_LINKER_FLAGS "-pie")
endif()

add_subdirectory(libdmr)
#add_subdirectory(test)

=== src/libdmr/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

project(libdmr VERSION 0.1.0)

set(CMAKE_AUTOMOC ON)
set(CMD_NAME dmr)

add_definitions(-D_LIBDMR_)
remove_definitions(-D_MOVIE_USE_)

pkg_check_modules(Gst REQUIRED IMPORTED_TARGET gstreamer-1.0 glib-2.0)

include_directories(${CMAKE_INCLUDE_CURRENT_DIR})

file(GLOB_RECURSE SRCS LIST_DIRECTORIES false *.cpp)
file(GLOB_RECURSE MPV_SRCS LIST_DIRECTORIES false ../backends/mpv/*.cpp)
file(GLOB_RECURSE MEDIAPLAYER_SRCS LIST_DIRECTORIES false ../backends/mediaplayer/*.cpp)
file(GLOB_RECURSE HWDEC_SRCS ../common/hwdec_probe.cpp)
list(APPEND SRCS player_widget.cpp ${MPV_SRCS} ${MEDIAPLAYER_SRCS} ${HWDEC_SRCS})

add_library(${CMD_NAME} SHARED ${SRCS})
set_target_properties(${CMD_NAME} PROPERTIES VERSION 0.1.0 SOVERSION 0.1)

target_include_directories(${CMD_NAME} PUBLIC
    ${PROJECT_SOURCE_DIR}/../common ${PROJECT_SOURCE_DIR}/../backends/mediaplayer ${PROJECT_SOURCE_DIR}/../backends/mpv /usr/include/glib-2.0 /usr/include/gstreamer-1.0)

target_link_libraries(${CMD_NAME} PkgConfig::Dtk Qt5::Widgets Qt5::Concurrent
    Qt5::Network Qt5::X11Extras Qt5::Sql Qt5::Svg Qt5::Multimedia Qt5::MultimediaWidgets Qt5::DBus PkgConfig::Gst GL)
#target_link_libraries(${CMD_NAME} PkgConfig::Dtk Qt5::Widgets Qt5::Concurrent
#    Qt5::Network Qt5::X11Extras Qt5::Sql Qt5::DBus PkgConfig::AV GL png jpeg)


configure_file(libdmr.pc.in ${PROJECT_BINARY_DIR}/libdmr.pc @ONLY)

install(TARGETS ${CMD_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES
    player_widget.h
    player_backend.h
    player_engine.h
    playlist_model.h
    movie_configuration.h
    compositing_manager.h
    utils.h
    online_sub.h
    DESTINATION include/libdmr)

install(FILES ${PROJECT_BINARY_DIR}/libdmr.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== debian/changelog ===
deepin-movie-reborn (5.10.15-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 17 Nov 2022 10:44:01 +0800

deepin-movie-reborn (5.10.0) unstable; urgency=medium

  * New version 5.10.0.

 -- fengli <fengli@uniontech.com>  Tue, 13 Jul 2022 10:08:00 +0800

=== debian/control ===
Source: deepin-movie-reborn
Section: libdevel
Priority: extra
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: debhelper, cmake, pkg-config, qttools5-dev-tools,
                libqt5svg5-dev, qtmultimedia5-dev, qttools5-dev,
                libqt5x11extras5-dev, libdtkcore5-bin, libdtkwidget-dev,
                libqt5sql5-sqlite,
                libmpv-dev, libxcb1-dev, libxcb-util0-dev,
                libffmpegthumbnailer-dev,
                libxcb-shape0-dev,libxcb-ewmh-dev, xcb-proto,
                x11proto-record-dev, libxtst-dev,
                libavcodec-dev, libavformat-dev,libavutil-dev,
                libpulse-dev, libdvdnav-dev, libgsettings-qt-dev,
                libmpris-qt5-dev, libdbusextended-qt5-dev, libva-dev,
                libgstreamer-plugins-base1.0-dev, libgstreamer1.0-dev
Standards-Version: 3.9.8
Homepage: https://www.deepin.org/

Package: deepin-movie
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, va-driver-all, libavcodec58(>= 7:4.0), libavformat58(>= 7:4.1), libavutil56(>= 7:4.0), libffmpegthumbnailer4v5, libmpv1(>= 0.29), libpulse0(>= 0.99.1), libqt5concurrent5, libmpris-qt5-1, libgstreamer-plugins-base1.0-0 (>= 1.0.0), libgstreamer1.0-0 (>= 1.4.0)
Recommends: libgpuinfo, uos-reporter, deepin-event-log
Description: movie player
 Movie is a full-featured video player, supporting playing local and streaming media in multiple video formats.

Package: libdmr
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libavcodec58(>= 7:4.0), libavformat58(>= 7:4.1), libavutil56(>= 7:4.0), libffmpegthumbnailer4v5, libmpv1(>= 0.29), libpulse0(>= 0.99.1), libqt5concurrent5, libmpris-qt5-1, libgstreamer-plugins-base1.0-0 (>= 1.0.0), libgstreamer1.0-0 (>= 1.4.0)
Multi-Arch: same
Description: movie player widget library 
 deepin movie player widget library

Package: libdmr-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdmr(=${binary:Version}), libgsettings-qt-dev
Description: movie player widget library development headers
 deepin movie player widget library development headers

## deepin-movie-reborn 5.10.17

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(deepin-movie-reborn)


option(USE_DXCB "integration with dxcb platform plugin" OFF)
option(DMR_DEBUG "turn on debug output" off)
option(DTK_DMAN_PORTAL "turn on dman portal support" off)

execute_process(COMMAND uname -m OUTPUT_VARIABLE MACH
    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(DMR_DEBUG on)
endif()

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
endif()

set(CMAKE_CXX_STANDARD 17)

set(CMAKE_EXPORT_COMPILE_COMMANDS on)

find_package(PkgConfig REQUIRED)

pkg_check_modules(MPRIS REQUIRED IMPORTED_TARGET mpris-qt5)

# test deepin fork mpris-qt5
try_compile(USE_FORK_MPRIS
              ${CMAKE_CURRENT_BINARY_DIR}/try_compile
            SOURCES
              ${CMAKE_CURRENT_SOURCE_DIR}/tests/mpris_test.cc
            LINK_LIBRARIES
              PkgConfig::MPRIS
            OUTPUT_VARIABLE TRY_COMPILE_OUTPUT
)

message(STATUS "use deepin fork mpris-qt5: ${USE_FORK_MPRIS}")

if(USE_FORK_MPRIS)
  add_definitions(-DUSE_FORK_MPRIS)
endif()

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)

include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR})

include(GNUInstallDirs)
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
   set(CMAKE_INSTALL_PREFIX /usr)
endif()

configure_file(${PROJECT_SOURCE_DIR}/config.h.in ${PROJECT_BINARY_DIR}/config.h @ONLY)

add_subdirectory(src)
add_subdirectory(examples/test)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_subdirectory(tests)
endif()

=== debian/changelog ===
deepin-movie-reborn (5.10.17-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Fri, 02 Dec 2022 11:13:41 +0800

## deepin-movie-reborn 5.10.22

=== examples/test/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

project(libdmr_test)

set(CMAKE_AUTOMOC ON)
set(CMD_NAME dmr_test)

set(CMAKE_CXX_FLAGS "-std=c++1y -fpermissive -Wno-error")

include_directories(${CMAKE_INCLUDE_CURRENT_DIR})

find_package(Qt5Widgets)
find_package(Qt5Concurrent)
find_package(Qt5Network)
find_package(Qt5X11Extras)
find_package(Qt5Sql)
find_package(Qt5DBus)
find_package(Qt5Svg)

pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkwidget)
pkg_check_modules(Gst REQUIRED IMPORTED_TARGET gstreamer-1.0 glib-2.0)

# 定义 source 文件
FILE (GLOB SRCS
    *.cpp
    )

add_executable(${CMD_NAME} ${SRCS})

target_link_libraries(${CMD_NAME} PkgConfig::Dtk Qt5::Widgets Qt5::Concurrent
    Qt5::Network Qt5::X11Extras Qt5::Sql Qt5::DBus PkgConfig::Gst GL)
target_include_directories(${CMD_NAME} PUBLIC 
    ${PROJECT_SOURCE_DIR}/../../src/libdmr
    ${PROJECT_SOURCE_DIR}
    /usr/include/glib-2.0 /usr/include/gstreamer-1.0)

target_link_libraries(${CMD_NAME} Qt5::Widgets dmr)

=== debian/changelog ===
deepin-movie-reborn (5.10.22-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 03 Apr 2023 14:22:49 +0800

deepin-movie-reborn (5.10.22) unstable; urgency=medium

  * New version 5.10.22.

 -- xiepengfei <xiepengfei@uniontech.com>  Wed, 09 Feb 2023 09:18:46 +0800

deepin-movie-reborn (5.10.21) unstable; urgency=medium

  * New version 5.10.21.

 -- xiepengfei <xiepengfei@uniontech.com>  Mon, 09 Jan 2023 13:10:20 +0800

deepin-movie-reborn (5.10.19) unstable; urgency=medium

  * New version 5.10.19.

 -- xiepengfei <xiepengfei@uniontech.com>  Tue, 27 Dec 2022 16:49:20 +0800

## deepin-movie-reborn 5.10.38

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -26,6 +26,7 @@
 find_package(Qt5Multimedia)
 find_package(Qt5MultimediaWidgets)
 find_package(Qt5Xml)
+find_package(DtkWidget REQUIRED)
 
 pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkwidget)
 pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkcore)
@@ -98,6 +99,17 @@
     DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps
     RENAME deepin-movie.svg)
 install(DIRECTORY ${CMAKE_SOURCE_DIR}/assets/deepin-movie DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-manual/manual-assets/application/)
+install(FILES ${PROJECT_SOURCE_DIR}/assets/deepin-movie.json DESTINATION /usr/lib/uos-ai-assistant/functions)
+
+#hw机型增加DConfig配置
+set(APPID org.deepin.movie)
+set(configFile ${PROJECT_SOURCE_DIR}/assets/org.deepin.movie.minimode.json)
+if (DEFINED DSG_DATA_DIR)
+    message("-- DConfig is supported by DTK")
+    dconfig_meta_files(APPID ${APPID} FILES ${configFile})
+else()
+    install(FILES ${configFile} DESTINATION ${CMAKE_INSTALL_DATADIR}/dsg/configs/org.deepin.movie/)
+endif()
 
 # 加速编译优化参数
 if (CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")

=== debian/changelog ===
deepin-movie-reborn (5.10.38-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 14 Dec 2023 20:00:01 +0800

deepin-movie-reborn (5.10.38) unstable; urgency=medium

  * NNew version 5.10.38.

 -- muyuankai <muyuankai@uniontech.com>  Thu, 14 Dec 2023 13:31:33 +0800

deepin-movie-reborn (5.10.37) unstable; urgency=medium

  * NNew version 5.10.37.

 -- muyuankai <muyuankai@uniontech.com>  Mon, 27 Nov 2023 10:17:45 +0800

deepin-movie-reborn (5.10.36) unstable; urgency=medium

  * New version 5.10.36.

 -- liuqingfu <liuqingfu@uniontech.com>  Fri, 03 Nov 2023 15:11:38 +0800

deepin-movie-reborn (5.10.35) unstable; urgency=medium

  * New version 5.10.35.

 -- xiepengfei <xiepengfei@uniontech.com>  Tues, 17 Oct 2023 10:15:17 +0800

deepin-movie-reborn (5.10.34) unstable; urgency=medium

  * New version 5.10.34.

 -- xiepengfei <xiepengfei@uniontech.com>  Fri, 13 Oct 2023 11:46:21 +0800

deepin-movie-reborn (5.10.33) unstable; urgency=medium

  * New version 5.10.33.

 -- xiepengfei <xiepengfei@uniontech.com>  Thu, 31 Aug 2023 16:15:39 +0800

deepin-movie-reborn (5.10.32) unstable; urgency=medium

  * New version 5.10.32.

 -- xiepengfei <xiepengfei@uniontech.com>  Fri, 04 Aug 2023 11:22:46 +0800

deepin-movie-reborn (5.10.31) unstable; urgency=medium

  * New version 5.10.31.

 -- xiepengfei <xiepengfei@uniontech.com>  Thu, 20 Jul 2023 10:10:21 +0800

deepin-movie-reborn (5.10.30) unstable; urgency=medium

  * New version 5.10.30.

 -- xiepengfei <xiepengfei@uniontech.com>  Web, 19 Jul 2023 11:01:13 +0800

deepin-movie-reborn (5.10.29) unstable; urgency=medium

  * New version 5.10.29.

 -- xiepengfei <xiepengfei@uniontech.com>  Web, 12 Jul 2023 14:20:56 +0800

deepin-movie-reborn (5.10.28) unstable; urgency=medium

  * New version 5.10.28.

 -- muyuankai <muyuankai@uniontech.com>  Web, 07 Jun 2023 11:42:45 +0800

deepin-movie-reborn (5.10.27) unstable; urgency=medium

  * New version 5.10.27.

 -- muyuankai <muyuankai@uniontech.com>  Mon, 08 May 2023 15:50:21 +0800

deepin-movie-reborn (5.10.26) unstable; urgency=medium

  * New version 5.10.26.

 -- xiepengfei <xiepengfei@uniontech.com>  Sun, 23 Apr 2023 16:20:15 +0800

deepin-movie-reborn (5.10.25) unstable; urgency=medium

  * New version 5.10.25.

 -- xiepengfei <xiepengfei@uniontech.com>  Wed, 12 Apr 2023 10:03:46 +0800

deepin-movie-reborn (5.10.24) unstable; urgency=medium

  * New version 5.10.24.

 -- xiepengfei <xiepengfei@uniontech.com>  Wed, 29 Mar 2023 14:05:32 +0800

deepin-movie-reborn (5.10.23) unstable; urgency=medium

  * New version 5.10.23.

 -- xiepengfei <xiepengfei@uniontech.com>  Thu, 23 Feb 2023 10:21:46 +0800

## deepin-movie-reborn 5.15.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,7 @@
 set(CMAKE_EXPORT_COMPILE_COMMANDS on)
 
 find_package(PkgConfig REQUIRED)
+find_package(Qt5Core)
 
 pkg_check_modules(MPRIS REQUIRED IMPORTED_TARGET mpris-qt5)
 
@@ -33,6 +34,7 @@
               ${CMAKE_CURRENT_SOURCE_DIR}/tests/mpris_test.cc
             LINK_LIBRARIES
               PkgConfig::MPRIS
+              Qt5::Core
             OUTPUT_VARIABLE TRY_COMPILE_OUTPUT
 )

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -34,7 +34,11 @@
 pkg_check_modules(DBusextended REQUIRED IMPORTED_TARGET dbusextended-qt5)
 pkg_check_modules(Gst REQUIRED IMPORTED_TARGET gobject-2.0)
 # IMPORTED_TARGET failed to work for some of libs under flatpak env
-pkg_check_modules(Other REQUIRED  gsettings-qt)
+pkg_check_modules(Other REQUIRED gsettings-qt)
+
+# make linglong build success
+pkg_check_modules(3rd REQUIRED libavformat mpv libavcodec libffmpegthumbnailer gstreamer-1.0 glib-2.0)
+include_directories(${3rd_INCLUDE_DIRS})
 
 qt5_add_resources(RCS ../assets/resources.qrc)
 qt5_add_resources(RCS ../assets/icons/theme-icons.qrc)
@@ -52,7 +56,6 @@
 list(APPEND SRCS ${MPV_SRCS} ${MEDIAPLAYER_SRCS})
 list(APPEND PROJECT_INCLUDE ${PROJECT_SOURCE_DIR}/src/backends/mpv)
 list(APPEND PROJECT_INCLUDE ${PROJECT_SOURCE_DIR}/src/backends/mediaplayer)
-list(APPEND PROJECT_INCLUDE /usr/include/glib-2.0 /usr/include/gstreamer-1.0)
 #~
 
 set (DTK_SETTINGS_TOOLS_EXECUTABLE ${DTKCORE_TOOL_DIR}/dtk-settings)
@@ -99,7 +102,8 @@
     DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps
     RENAME deepin-movie.svg)
 install(DIRECTORY ${CMAKE_SOURCE_DIR}/assets/deepin-movie DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-manual/manual-assets/application/)
-install(FILES ${PROJECT_SOURCE_DIR}/assets/deepin-movie.json DESTINATION /usr/lib/uos-ai-assistant/functions)
+install(FILES ${PROJECT_SOURCE_DIR}/assets/deepin-movie.json DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/uos-ai-assistant/functions)
+install(FILES ${PROJECT_SOURCE_DIR}/com.deepin.movie.service DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services/)
 
 #hw机型增加DConfig配置
 set(APPID org.deepin.movie)

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

set(CMAKE_CXX_STANDARD 17)

# 设置cmake参数
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

add_subdirectory(deepin-movie)
add_subdirectory(ut_dmr-test)
add_subdirectory(deepin-movie-platform)

=== examples/test/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 set(CMAKE_AUTOMOC ON)
 set(CMD_NAME dmr_test)
 
-set(CMAKE_CXX_FLAGS "-std=c++1y -fpermissive -Wno-error")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++1y -fpermissive -Wno-error")
 
 include_directories(${CMAKE_INCLUDE_CURRENT_DIR})
 
@@ -20,7 +20,8 @@
 find_package(Qt5Svg)
 
 pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkwidget)
-pkg_check_modules(Gst REQUIRED IMPORTED_TARGET gstreamer-1.0 glib-2.0)
+pkg_check_modules(Gst REQUIRED IMPORTED_TARGET libffmpegthumbnailer gstreamer-1.0 glib-2.0)
+include_directories(${Gst_INCLUDE_DIRS})
 
 # 定义 source 文件
 FILE (GLOB SRCS
@@ -34,7 +35,7 @@
 target_include_directories(${CMD_NAME} PUBLIC 
     ${PROJECT_SOURCE_DIR}/../../src/libdmr
     ${PROJECT_SOURCE_DIR}
-    /usr/include/glib-2.0 /usr/include/gstreamer-1.0)
+    )
 
 target_link_libraries(${CMD_NAME} Qt5::Widgets dmr)

=== src/libdmr/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,7 @@
 remove_definitions(-D_MOVIE_USE_)
 
 pkg_check_modules(Gst REQUIRED IMPORTED_TARGET gstreamer-1.0 glib-2.0)
+include_directories(${Gst_INCLUDE_DIRS})
 
 include_directories(${CMAKE_INCLUDE_CURRENT_DIR})
 
@@ -18,13 +19,14 @@
 file(GLOB_RECURSE MPV_SRCS LIST_DIRECTORIES false ../backends/mpv/*.cpp)
 file(GLOB_RECURSE MEDIAPLAYER_SRCS LIST_DIRECTORIES false ../backends/mediaplayer/*.cpp)
 file(GLOB_RECURSE HWDEC_SRCS ../common/hwdec_probe.cpp)
-list(APPEND SRCS player_widget.cpp ${MPV_SRCS} ${MEDIAPLAYER_SRCS} ${HWDEC_SRCS})
+file(GLOB_RECURSE UTIL_SRCS ../common/sysutils.cpp)
+list(APPEND SRCS player_widget.cpp ${MPV_SRCS} ${MEDIAPLAYER_SRCS} ${HWDEC_SRCS} ${UTIL_SRCS})
 
 add_library(${CMD_NAME} SHARED ${SRCS})
 set_target_properties(${CMD_NAME} PROPERTIES VERSION 0.1.0 SOVERSION 0.1)
 
 target_include_directories(${CMD_NAME} PUBLIC
-    ${PROJECT_SOURCE_DIR}/../common ${PROJECT_SOURCE_DIR}/../backends/mediaplayer ${PROJECT_SOURCE_DIR}/../backends/mpv /usr/include/glib-2.0 /usr/include/gstreamer-1.0)
+    ${PROJECT_SOURCE_DIR}/../common ${PROJECT_SOURCE_DIR}/../backends/mediaplayer ${PROJECT_SOURCE_DIR}/../backends/mpv)
 
 target_link_libraries(${CMD_NAME} PkgConfig::Dtk Qt5::Widgets Qt5::Concurrent
     Qt5::Network Qt5::X11Extras Qt5::Sql Qt5::Svg Qt5::Multimedia Qt5::MultimediaWidgets Qt5::DBus PkgConfig::Gst GL)

=== tests/deepin-movie-platform/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

# 设置cmake参数
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

#ADD_DEFINITIONS( -LITE_DIV)
execute_process(COMMAND uname -m OUTPUT_VARIABLE MACH
    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)

option (USE_TEST "Use TESTS" ON)
add_definitions( -DUSE_TEST )

# 设置Qt模块
set(QtModule Core Gui Widgets Network X11Extras PrintSupport DBus Sql Svg Multimedia MultimediaWidgets Concurrent LinguistTools Test Xml)

# 设置工程名字
project(deepin-movie-platform-test)

# 查找Qt相关的库链接
find_package(Qt5 REQUIRED ${QtModule})


# 包含源码文件夹
include_directories(${CMAKE_INCLUDE_CURRENT_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

include_directories(../../src)
include_directories(../../src/common)
include_directories(../../src/common/platform)
include_directories(../../src/widgets)
include_directories(../../src/widgets/platform)
include_directories(../../src/libdmr)
include_directories(../../src/vendor)
include_directories(../../src/backends)
include_directories(../../src/backends/mpv)
include_directories(../../src/backends/mediaplayer)
include_directories(../../src/dlna)
include_directories(../../src/dlna/dlnaHttpServer)

#add_subdirectory(googletest)

# 定义 source 文件
FILE (GLOB allSource
    ../../src/common/*.cpp
    ../../src/common/platform/*.cpp
    ../../src/widgets/*.cpp
    ../../src/widgets/platform/*.cpp
    ../../src/libdmr/*.cpp
    ../../src/vendor/*.cpp
    ../../src/backends/mpv/*.cpp
    ../../src/backends/mediaplayer/*.cpp
    ../../src/backends/*.cpp
    ../../src/dlna/*.cpp
    ../../src/dlna/dlnaHttpServer/*.cpp
    ../../src/dlna/dlnaHttpServer/*.c
    )

FILE (GLOB allTestSource
    *.cpp
    *.sh
    common/*.cpp
    widgets/*.cpp
    libdmr/*.cpp
    backends/*.cpp
    vendor/*.cpp
    *.sh
    )

# 定义资源文件
set(AllQRC
    ../../assets/resources.qrc
    ../../assets/icons/theme-icons.qrc
)

# 设置不删除生成的文件夹内容文件（设置此项是为了翻译后的文件不被删除）
set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM 1)

# 添加需要安装的模块
add_executable(${PROJECT_NAME} ${allSource} ${allTestSource}
    ${AllQRC}
    )

# 添加gocv覆盖率文件的输出
if (CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")
    set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")    #mips平台下不进行内存检测
else()
    set(CMAKE_CXX_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -fprofile-arcs -ftest-coverage")
    set(CMAKE_C_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
    set(CMAKE_L_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
endif()

set(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE ON)

set(OBJECT_DIR ${CMAKE_BINARY_DIR}/CMakeFiles/objects)

add_custom_target(platform_test
    COMMAND mkdir -p build-ut
    COMMAND mkdir -p build-ut/report
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

add_custom_command(TARGET platform_test
    COMMAND echo " ===================CREAT LCOV REPROT==================== "
    COMMAND lcov --directory ./CMakeFiles/${PROJECT_NAME}.dir --zerocounters
    COMMAND ./tests/${PROJECT_NAME} #-o ./build-ut/report/report_${PROJECT_NAME}.xml,xml
    COMMAND lcov --directory . --capture --output-file ./build-ut/${PROJECT_NAME}_Coverage.info

    COMMAND echo " =================== do filter begin ==================== "
    COMMAND lcov --remove ./build-ut/${PROJECT_NAME}_Coverage.info 'CMakeFiles/${PROJECT_NAME}.dir/${PROJECT_NAME}_autogen/*/*'
    '${PROJECT_NAME}_autogen/*/*/*.cpp' 'googletest/*/*' '*/usr/include/*' '*/tests/*' '/usr/local/*' '*/src/common/filter.*'
    '*/src/common/settings_translation.cpp' '*/src/common/event_monitor.cpp' '*/src/widgets/videoboxbutton.cpp' '*/src/common/event_relayer.cpp'
    -o ./build-ut/${PROJECT_NAME}_Coverage_fileter.info
    COMMAND echo " =================== do filter end ==================== "

    COMMAND genhtml -o ./build-ut/report ./build-ut/${PROJECT_NAME}_Coverage_fileter.info
    COMMAND echo " -- Coverage files have been output to ${CMAKE_BINARY_DIR}/build-ut/report "
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
add_dependencies(platform_test ${PROJECT_NAME})

#------------------------------ 添加第三方库  DTK -------------------------------
# 使用第三方库需要用到的一个包
find_package(PkgConfig REQUIRED)
#set(TARGET_LIBS X11 Xext Xtst PkgConfig::Xcb Qt5::Widgets Qt5::X11Extras Qt5::Network
#    Qt5::Concurrent Qt5::DBus Qt5::Sql PkgConfig::Dtk
#    PkgConfig::Mpv PkgConfig::MPRIS PkgConfig::DBusextended
#    PkgConfig::AV pthread GL)
# 检查第三方库(这里检查了名字为dtkwidget的库和名字为dtkgui的库)，然后取名3rd_lib
pkg_check_modules(3rd_lib REQUIRED
        dtkwidget dtkgui
        libpulse dvdnav gsettings-qt x11 xext xtst xcb gl
        xcb-aux xcb-proto xcb-ewmh xcb-shape mpris-qt5 dbusextended-qt5 libva libva-x11
        gstreamer-1.0 glib-2.0 gstreamer-pbutils-1.0
        )
    #libpulse-simple xcb-aux gtest
# 添加第三方库的所有文件夹路径到工程中来(注意 *_INCLUDE_DIRS)
target_include_directories(${PROJECT_NAME} PUBLIC ${3rd_lib_INCLUDE_DIRS})

# 将第三方库链接进来(注意 *_LIBRARIES)
target_link_libraries(${PROJECT_NAME} ${3rd_lib_LIBRARIES}  Qt5::GuiPrivate)
#------------------------------添加第三方库end-------------------------------------

target_link_libraries(${PROJECT_NAME} gmock gmock_main gtest gtest_main)

# 将工程与Qt模块链接起来
qt5_use_modules(${PROJECT_NAME} ${QtModule})

=== tests/deepin-movie/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

# 设置cmake参数
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_CXX_STANDARD 17)

#ADD_DEFINITIONS( -LITE_DIV)
execute_process(COMMAND uname -m OUTPUT_VARIABLE MACH
    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)

option (USE_TEST "Use TESTS" ON)
add_definitions( -DUSE_TEST )

# 设置Qt模块
set(QtModule Core Gui Widgets Network X11Extras PrintSupport DBus Sql Svg Multimedia MultimediaWidgets Concurrent LinguistTools Test Xml)

# 设置工程名字
project(deepin-movie-test)

# 查找Qt相关的库链接
find_package(Qt5 REQUIRED ${QtModule})
find_package(Qt5Xml)
find_package(Qt5Test)


# 包含源码文件夹
include_directories(${CMAKE_INCLUDE_CURRENT_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

include_directories(../../src)
include_directories(../../src/common)
include_directories(../../src/common/platform)
include_directories(../../src/widgets)
include_directories(../../src/widgets/platform)
include_directories(../../src/libdmr)
include_directories(../../src/vendor)
include_directories(../../src/backends)
include_directories(../../src/backends/mpv)
include_directories(../../src/backends/mediaplayer)
include_directories(../../src/dlna)
include_directories(../../src/dlna/dlnaHttpServer)

#add_subdirectory(googletest)

# 定义 source 文件
FILE (GLOB allSource
    ../../src/common/*.cpp
    ../../src/common/platform/*.cpp
    ../../src/widgets/*.cpp
    ../../src/widgets/platform/*.cpp
    ../../src/libdmr/*.cpp
    ../../src/vendor/*.cpp
    ../../src/backends/mpv/*.cpp
    ../../src/backends/mediaplayer/*.cpp
    ../../src/backends/*.cpp
    ../../src/dlna/*.cpp
    ../../src/dlna/dlnaHttpServer/*.cpp
    ../../src/dlna/dlnaHttpServer/*.c
    )

FILE (GLOB allTestSource
    *.cpp
    *.sh
    common/*.cpp
    dlna/*.cpp
    libdmr/*.cpp
    backends/*.cpp
    vendor/*.cpp
    stub/*.cpp
    *.sh
    )

# 定义资源文件
set(AllQRC
    ../../assets/resources.qrc
    ../../assets/icons/theme-icons.qrc
)

# 设置不删除生成的文件夹内容文件（设置此项是为了翻译后的文件不被删除）
set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM 1)

# 添加需要安装的模块
add_executable(${PROJECT_NAME} ${allSource} ${allTestSource}
    ${AllQRC}
    )

# 添加gocv覆盖率文件的输出
if (CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")
    set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")    #mips平台下不进行内存检测
else()
    set(CMAKE_CXX_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -fprofile-arcs -ftest-coverage")
    set(CMAKE_C_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
    set(CMAKE_L_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
endif()

set(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE ON)

set(OBJECT_DIR ${CMAKE_BINARY_DIR}/CMakeFiles/objects)

add_custom_target(test
    COMMAND mkdir -p build-ut
    COMMAND mkdir -p build-ut/report
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

add_custom_command(TARGET test
    COMMAND echo " ===================CREAT LCOV REPROT==================== "
    COMMAND lcov --directory ./CMakeFiles/${PROJECT_NAME}.dir --zerocounters
    COMMAND ./tests/${PROJECT_NAME} #-o ./build-ut/report/report_${PROJECT_NAME}.xml,xml
    COMMAND lcov --directory . --capture --output-file ./build-ut/${PROJECT_NAME}_Coverage.info

    COMMAND echo " =================== do filter begin ==================== "
    COMMAND lcov --remove ./build-ut/${PROJECT_NAME}_Coverage.info 'CMakeFiles/${PROJECT_NAME}.dir/${PROJECT_NAME}_autogen/*/*'
    '${PROJECT_NAME}_autogen/*/*/*.cpp' 'googletest/*/*' '*/usr/include/*' '*/tests/*' '/usr/local/*' '*/src/common/filter.*'
    '*/src/common/settings_translation.cpp' '*/src/common/event_monitor.cpp' '*/src/widgets/videoboxbutton.cpp' '*/src/common/event_relayer.cpp'
    -o ./build-ut/${PROJECT_NAME}_Coverage_fileter.info
    COMMAND echo " =================== do filter end ==================== "

    COMMAND genhtml -o ./build-ut/report ./build-ut/${PROJECT_NAME}_Coverage_fileter.info
    COMMAND echo " -- Coverage files have been output to ${CMAKE_BINARY_DIR}/build-ut/report "
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
add_dependencies(test ${PROJECT_NAME})

#------------------------------ 添加第三方库  DTK -------------------------------
# 使用第三方库需要用到的一个包
find_package(PkgConfig REQUIRED)
#set(TARGET_LIBS X11 Xext Xtst PkgConfig::Xcb Qt5::Widgets Qt5::X11Extras Qt5::Network
#    Qt5::Concurrent Qt5::DBus Qt5::Sql PkgConfig::Dtk
#    PkgConfig::Mpv PkgConfig::MPRIS PkgConfig::DBusextended
#    PkgConfig::AV pthread GL)
# 检查第三方库(这里检查了名字为dtkwidget的库和名字为dtkgui的库)，然后取名3rd_lib
pkg_check_modules(3rd_lib REQUIRED
        dtkwidget dtkgui
        libpulse dvdnav gsettings-qt x11 xext xtst xcb gl
        xcb-aux xcb-proto xcb-ewmh xcb-shape mpris-qt5 dbusextended-qt5 libva libva-x11
        gstreamer-1.0 glib-2.0 gstreamer-pbutils-1.0
        )
    #libpulse-simple xcb-aux gtest
# 添加第三方库的所有文件夹路径到工程中来(注意 *_INCLUDE_DIRS)
target_include_directories(${PROJECT_NAME} PUBLIC ${3rd_lib_INCLUDE_DIRS})

# 将第三方库链接进来(注意 *_LIBRARIES)
target_link_libraries(${PROJECT_NAME} ${3rd_lib_LIBRARIES}  Qt5::GuiPrivate Qt5::Test
    ${GTEST_LIBRARIES}
    ${GTEST_MAIN_LIBRARIES})
#------------------------------添加第三方库end-------------------------------------

target_link_libraries(${PROJECT_NAME} gmock gmock_main gtest gtest_main)

# 将工程与Qt模块链接起来
qt5_use_modules(${PROJECT_NAME} ${QtModule})

=== tests/ut_dmr-test/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

# 设置工程名字
project(ut_dmr-test)

# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

# 设置cmake参数
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

execute_process(COMMAND uname -m OUTPUT_VARIABLE MACH
    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)

option (USE_TEST "Use TESTS" ON)
add_definitions( -DUSE_TEST )

# 设置Qt模块
set(QtModule Core Gui Widgets Network X11Extras PrintSupport DBus Sql Svg Concurrent LinguistTools Test)

# 查找Qt相关的库链接
find_package(Qt5 REQUIRED ${QtModule})

pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkwidget)

include_directories(../../examples/test)
include_directories(../../src)
include_directories(../../src/common)
include_directories(../../src/widgets)
include_directories(../../src/libdmr)
include_directories(../../src/vendor)
include_directories(../../src/backends)
include_directories(../../src/backends/mpv)

# 定义 source 文件
FILE (GLOB allSource
    ../../examples/test/window.cpp
    )

FILE (GLOB allTestSource
    *.cpp
    *.sh
    )

# 定义资源文件
set(AllQRC
    ../../assets/resources.qrc
    ../../assets/icons/theme-icons.qrc
)

add_executable(${PROJECT_NAME} ${allSource} ${allTestSource} ${AllQRC})

#添加内存泄露检测参数
if (CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")
    set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")    #mips平台下不进行内存检测
else()
    set(CMAKE_CXX_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -fprofile-arcs -ftest-coverage")
    set(CMAKE_C_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
    set(CMAKE_L_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
endif()

set(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE ON)

set(OBJECT_DIR ${CMAKE_BINARY_DIR}/CMakeFiles/objects)

# 使用第三方库需要用到的一个包
find_package(PkgConfig REQUIRED)
pkg_check_modules(3rd_lib REQUIRED
        dtkwidget dtkgui
        libpulse dvdnav gsettings-qt x11 xext xtst xcb gl
        xcb-aux xcb-proto xcb-ewmh xcb-shape mpris-qt5 dbusextended-qt5 libva libva-x11
        )
    #libpulse-simple xcb-aux gtest
# 添加第三方库的所有文件夹路径到工程中来(注意 *_INCLUDE_DIRS)
target_include_directories(${PROJECT_NAME} PUBLIC ${3rd_lib_INCLUDE_DIRS})

# 将第三方库链接进来(注意 *_LIBRARIES)
target_link_libraries(${PROJECT_NAME} ${3rd_lib_LIBRARIES} )
#------------------------------添加第三方库end-------------------------------------

target_link_libraries(${PROJECT_NAME} gmock gmock_main gtest gtest_main dmr)

# 将工程与Qt模块链接起来
qt5_use_modules(${PROJECT_NAME} ${QtModule})

=== debian/changelog ===
deepin-movie-reborn (5.15.10-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1112834)

 -- Adrian Bunk <bunk@debian.org>  Sun, 19 Oct 2025 22:15:23 +0300

deepin-movie-reborn (5.15.10-3) unstable; urgency=medium

  * debian/control: Revert last change. (Closes: #1101846)

 -- Boyuan Yang <byang@debian.org>  Sat, 05 Apr 2025 10:10:34 -0400

deepin-movie-reborn (5.15.10-2) unstable; urgency=medium

  * debian/control: Add missing build-dep libdisplay-info-dev.
    (Closes: #1101846)

 -- Boyuan Yang <byang@debian.org>  Tue, 01 Apr 2025 19:19:53 -0400

deepin-movie-reborn (5.15.10-1) unstable; urgency=medium

  * New upstream release. (Closes: #1096240)
  * debian/deepin-movie.install: Updated.
  * debian/patches: Drop old patch (001, 002, 006).

 -- Boyuan Yang <byang@debian.org>  Mon, 17 Feb 2025 18:55:40 -0500

deepin-movie-reborn (5.10.8-3) unstable; urgency=medium

  [ Arun Kumar Pariyar ]
  * Fix ftbfs with ffmpeg 7 (Closes: #1078277).
  * Fix ts file regeneration in double-build (Closes: #1045091).
  * Add debian/clean with generated qm files.

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Replace dependency on transitional package
      x11proto-record-dev with replacement x11proto-dev.

 -- Arun Kumar Pariyar <arun@debian.org>  Mon, 16 Sep 2024 03:20:17 +0545

deepin-movie-reborn (5.10.8-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Change hardcoded dependency to libqt5concurrent5t64 instead of
    libqt5concurrent5. Closes: #1068224

 -- Andreas Metzler <ametzler@debian.org>  Sun, 21 Apr 2024 13:23:59 +0200

deepin-movie-reborn (5.10.8-2) unstable; urgency=medium

  * debian/control:
    + Drop version constraints on libpulse0 and libqt5concurrent5.
    + Replace hardcoded shared library libmpv with ${libmpv:Depends}.
  * debian/rules:
    + Add mpv shared library using dh_shlibdeps-arch. (Closes #1025008)

 -- Arun Kumar Pariyar <arun@debian.org>  Thu, 01 Dec 2022 04:57:34 +0545

=== debian/control ===
Source: deepin-movie-reborn
Section: video
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Yangfl <mmyangfl@gmail.com>,
 Boyuan Yang <byang@debian.org>,
 Yanhao Mo <yanhaocs@gmail.com>,
 Arun Kumar Pariyar <arun@debian.org>,
 Clay Stan <claystan97@gmail.com>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libavcodec-dev,
 libavformat-dev,
 libavutil-dev,
 libdbusextended-qt5-dev,
 libdtkcore5-bin (>= 5.5~),
 libdtkwidget-dev (>= 5.5~),
 libdvdnav-dev,
 libffmpegthumbnailer-dev,
 libgsettings-qt-dev,
 libgstreamer-plugins-base1.0-dev,
 libgstreamer1.0-dev,
 libmpris-qt5-dev,
 libmpv-dev,
 libpulse-dev,
 libqt5sql5-sqlite,
 libqt5svg5-dev,
 libqt5x11extras5-dev,
 libva-dev,
 libxcb-ewmh-dev,
 libxcb-shape0-dev,
 libxcb-util-dev,
 libxcb1-dev,
 libxtst-dev,
 pkgconf,
 qtmultimedia5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 x11proto-dev,
 xcb-proto,
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: https://github.com/linuxdeepin/deepin-movie-reborn
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-movie-reborn.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-movie-reborn

Package: deepin-movie
Architecture: any
Depends:
 libdmr0.1 (= ${binary:Version}),
 libffmpegthumbnailer4v5,
 libgstreamer-plugins-base1.0-0,
 libgstreamer1.0-0,
 libmpris-qt5-1 (>= 0.1.0.1),
 libpulse0,
 libqt5concurrent5t64,
 va-driver-all,
 ${libmpv:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 libgpuinfo,
Description: Deepin movie player
 Deepin Movie provides an intuitive easy to use operation interface and rich
 complete shortcuts. You can complete all play operations by keyboard, which
 will make you thoroughly get rid of the constraint of mouse click. Video files
 in various formats can be played through Deepin Movie, and you can use the
 streaming function to easily enjoy online video resources.
 .
 This package is part of DDE (Deepin Desktop Environment).

Package: libdmr-dev
Section: libdevel
Architecture: any
Depends:
 libdmr0.1 (= ${binary:Version}),
 libgsettings-qt-dev,
 ${misc:Depends},
Multi-Arch: same
Description: Deepin movie player - widget library (development files)
 Deepin Movie provides an intuitive easy to use operation interface and rich
 complete shortcuts. You can complete all play operations by keyboard, which
 will make you thoroughly get rid of the constraint of mouse click. Video files
 in various formats can be played through Deepin Movie, and you can use the
 streaming function to easily enjoy online video resources.
 .
 This package is part of DDE (Deepin Desktop Environment).
 .
 This package contains the header files for the widget library.

Package: libdmr0.1
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 libffmpegthumbnailer4v5,
 libgstreamer-plugins-base1.0-0,
 libmpris-qt5-1 (>= 0.1.0.1),
 libpulse0,
 libqt5concurrent5t64,
 ${libmpv:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Description: Deepin movie player - widget library
 Deepin Movie provides an intuitive easy to use operation interface and rich
 complete shortcuts. You can complete all play operations by keyboard, which
 will make you thoroughly get rid of the constraint of mouse click. Video files
 in various formats can be played through Deepin Movie, and you can use the
 streaming function to easily enjoy online video resources.
 .
 This package is part of DDE (Deepin Desktop Environment).
 .
 This package contains the widget library.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
export DEB_CXXFLAGS_MAINT_APPEND = -Wl,-z,now
export QT_SELECT := 5
mpvpkgname := $(shell dpkg-query --show '--showformat=$${Depends}' libmpv-dev | cut -d ' ' -f1)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DCMAKE_BUILD_TYPE=Release \
	  -DCMAKE_INSTALL_PREFIX=/usr \
      -DAPP_VERSION=$(DEB_VERSION_UPSTREAM) -DVERSION=$(DEB_VERSION_UPSTREAM) LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

execute_after_dh_shlibdeps-arch:
	echo libmpv:Depends=$(mpvpkgname) >> debian/deepin-movie.substvars
	echo libmpv:Depends=$(mpvpkgname) >> debian/libdmr0.1.substvars

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%deepin-movie-reborn-$1.tar.gz%" \
   https://github.com/linuxdeepin/deepin-movie-reborn/tags \
   (?:.*?/)?(\d[\d.]*)\.tar\.gz debian uupdate

## deepin-movie-reborn 6.0.10

=== debian/changelog ===
deepin-movie-reborn (6.0.10) unstable; urgency=medium

  * New version 6.0.10. 

 -- zhanghongyuan <zhanghongyuan@uniontech.com>  Thu, 04 Jul 2024 16:03:18 +0800

deepin-movie-reborn (6.0.9) unstable; urgency=medium

  * New version 6.0.9.

 -- muyuankai <muyuankai@uniontech.com>  Wed, 26 Jun 2024 16:09:09 +0800

deepin-movie-reborn (6.0.8) unstable; urgency=medium

  * New version 6.0.8.

 -- xiepengfei <xiepengfei@uniontech.com>  Tue, 28 May 2024 15:04:22 +0800

deepin-movie-reborn (6.0.7) unstable; urgency=medium

  * New version 6.0.7.

 -- lijiaxuan <lijiaxuan@uniontech.com>  Fri, 12 Apr 2024 16:12:30 +0800

deepin-movie-reborn (6.0.6) unstable; urgency=medium

  * New version 6.0.6.

 -- muyuankai <muyuankai@uniontech.com>  Tue, 16 Jan 2024 11:42:05 +0800

deepin-movie-reborn (6.0.5) unstable; urgency=medium

  * New version 6.0.5.

 -- xiepengfei <xiepengfei@uniontech.com>  Mon, 06 Feb 2023 14:20:00 +0800

deepin-movie-reborn (6.0.4) unstable; urgency=medium

  * New version 6.0.4.

 -- xiepengfei <xiepengfei@uniontech.com>  Mon, 06 Feb 2023 10:40:00 +0800
